//=====================================================================
//  Chen-Chieh (Jay) Wang
//  ccwang@mail.ee.ncku.edu.tw
//  http://caslab.ee.ncku.edu.tw/~jay
//---------------------------------------------------------------------
//  Computer Architecture and System Laboratory (CASLab)
//  Institute of Computer and Communication Engineering
//  National Cheng Kung University, Tainan, Taiwan.
//  http://caslab.ee.ncku.edu.tw
//=====================================================================
#include <systemc.h>
#include <stdio.h>
#include "top_design.h"

//=====================================================================
//  Prototype Declarations
//=====================================================================


//=====================================================================
//  Global Declarations
//=====================================================================
sc_trace_file *wf;

//=====================================================================
//	Functions
//=====================================================================

int sc_main(int argc, char* argv[]){

    //=================================================================
    //	Elaboration
    //=================================================================

    //Clock Generator
    sc_clock
        clk("clock",sc_time(10, SC_NS), 0.5, sc_time(5, SC_NS), true );

	//Top Module
    top_design
    	top("SC_TOP");
    	top.clk(clk);

	//Waveform (VCD) Dump
	wf = sc_create_vcd_trace_file("./out/WAVE");
	wf->set_time_unit(100, SC_PS);

		sc_trace(wf, clk, 				"clk");
		sc_trace(wf, top.a_value, 		"a_value");
		sc_trace(wf, top.b_value, 		"b_value");
		sc_trace(wf, top.a_value_copy, 	"a_value_copy");
		sc_trace(wf, top.b_value_copy, 	"b_value_copy");

    //=================================================================
    //  Simulation
    //=================================================================
	sc_start(100, SC_NS);

    //=================================================================
    //  cleanup
    //=================================================================
    return 0;// Terminate simulation

}

