//=====================================================================
//  Chen-Chieh (Jay) Wang
//  ccwang@mail.ee.ncku.edu.tw
//  http://caslab.ee.ncku.edu.tw/~jay
//---------------------------------------------------------------------
//  Computer Architecture and System Laboratory (CASLab)
//  Institute of Computer and Communication Engineering
//  National Cheng Kung University, Tainan, Taiwan.
//  http://caslab.ee.ncku.edu.tw
//=====================================================================
#include "top_design.h"

top_design::top_design(sc_module_name name_)
: sc_module(name_)
{

    //-----------------------------------------------------------------
    //  Initializations / Arch. Configuration
    //-----------------------------------------------------------------

    //-----------------------------------------------------------------
    //  Channel Allocations
    //-----------------------------------------------------------------

    //-----------------------------------------------------------------
    //  Submodule Allocations & Connectivity
    //-----------------------------------------------------------------

    //-----------------------------------------------------------------
    //  Process Registrations
    //-----------------------------------------------------------------
    SC_THREAD(a_thread);
        sensitive << clk.pos();
        dont_initialize();

    SC_THREAD(b_thread);
        sensitive << clk.pos();
        dont_initialize();

}


//=====================================================================
//  Process
//=====================================================================
void top_design::a_thread(void){

    uint32_t new_value;

    while(1){

        new_value = a_value.read() + 5;
        a_value.write(new_value);

        b_value_copy.write( b_value.read() );

        wait();
    }
}


void top_design::b_thread(void){

    uint32_t new_value;

    while(1){

        new_value = b_value.read() + 3;
        b_value.write(new_value);

        a_value_copy.write( a_value.read() );

        wait();
    }
}


//=====================================================================
//  Helper
//=====================================================================

