//=====================================================================
//  Chen-Chieh (Jay) Wang
//  ccwang@mail.ee.ncku.edu.tw
//  http://caslab.ee.ncku.edu.tw/~jay
//---------------------------------------------------------------------
//  Computer Architecture and System Laboratory (CASLab)
//  Institute of Computer and Communication Engineering
//  National Cheng Kung University, Tainan, Taiwan.
//  http://caslab.ee.ncku.edu.tw
//=====================================================================
#ifndef _TOP_DESIGN_H_
#define _TOP_DESIGN_H_

#include <systemc.h>
#include <stdio.h>
#include <stdint.h>

SC_MODULE(top_design){

  public:

    //-----------------------------------------------------------------
    //  Port Declarations
    //-----------------------------------------------------------------
    sc_in_clk               clk;

    //-----------------------------------------------------------------
    //  Submodule* Definitions
    //-----------------------------------------------------------------

    //-----------------------------------------------------------------
    //  Channel Definitions
    //-----------------------------------------------------------------
    sc_signal<uint32_t>     a_value;
    sc_signal<uint32_t>     b_value;
    sc_signal<uint32_t>     a_value_copy;
    sc_signal<uint32_t>     b_value_copy;

    //-----------------------------------------------------------------
    //  Constructor Declaration
    //-----------------------------------------------------------------
    SC_HAS_PROCESS(top_design);
    top_design(sc_module_name name_);

    //-----------------------------------------------------------------
    //  Process Declarations
    //-----------------------------------------------------------------
    void a_thread(void);
    void b_thread(void);

    //-----------------------------------------------------------------
    //  Helper Declarations
    //-----------------------------------------------------------------

  //private:

    //-----------------------------------------------------------------
    //  Private Variable Declarations
    //-----------------------------------------------------------------

    //-----------------------------------------------------------------
    //  Private Helper Declaration
    //-----------------------------------------------------------------

};

#endif
